#!/bin/bash

set -e

write-file() (
  local -r dst="$1"; shift || return
  local -r src="$1"; shift || return

  if [[ -f "${dst}" ]]; then
    local -r tmp="$(mktemp)" && trap "rm -f '${tmp}'" EXIT || return
    cp "${src}" "${tmp}"
    echo -n 'file1: '; cat "${tmp}"
    echo -n 'file2: '; cat "${dst}"
    if delta --side-by-side --paging never --width "$(tput cols)" "${dst}" "${tmp}"; then
      echo -e "\e[36m=\e[0m Already up to date: \e[36m${dst}\e[0m"
    else
      echo -e "\n\e[33m≠\e[0m File contents changed: \e[33m${dst}\e[0m\n"
      cp -i "${tmp}" "${dst}"
    fi
  else
    cp "${src}" "${dst}" && echo -e "\e[94m✓\e[0m Successfully wrote: \e[94m${dst}\e[0m"
  fi
)

write-file foo <( sed 's/bar/baz/' foo )
